/* opengl.h: 

   Unfortunately, the Mac OS X include paths don't match those on 
   Linux and Windows.  So this file performs all the GL includes with
   conditional compilation.
*/

#ifndef _INCLUDE_GL_H
#define _INCLUDE_GL_H

#define GL_GLEXT_PROTOTYPES 1

#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <OpenGL/glext.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#endif

#endif

/* In Cygwin/Windows, the OpenGL DLL doesn't define these symbols, so
   I have to do it myself. They are loaded in main.cc. */
#if defined(_WIN32) || defined(__CYGWIN__) || defined(__MINGW32__)

#define EXTENSIONS_NEEDS_LOADING 1
extern PFNGLMULTITEXCOORD2FARBPROC   ext_glMultiTexCoord2fARB;
extern PFNGLACTIVETEXTUREARBPROC     ext_glActiveTextureARB;
extern PFNGLACTIVETEXTUREARBPROC     ext_glClientActiveTextureARB;
extern PFNGLTEXIMAGE3DPROC           ext_glTexImage3D;

#define glActiveTextureARB ext_glActiveTextureARB
#define glClientActiveTextureARB ext_glClientActiveTextureARB
#define glMultiTexCoord2fARB ext_glMultiTexCoord2fARB
#define glTexImage3D ext_glTexImage3D

#endif
