#error do not use

struct Point2d {
  float x, y;
  Point2d(): x(0), y(0) {}
  Point2d(float x_, float y_): x(x_), y(y_) {}
};

struct Vector2d {
  float x, y;
  Vector2d(): x(0), y(0) {}
  Vector2d(float x_, float y_): x(x_), y(y_) {}
  float length() const {
    return sqrt(x*x + y*y);
  }
};

struct Vector3d {
  float x, y, z;
  Vector3d(): x(0), y(0), z(0) {}
  Vector3d(float x_, float y_, float z_): x(x_), y(y_), z(z_) {}
  float length() const {
    return sqrt(x*x + y*y + z*z);
  }
};

inline Vector2d operator * (const Vector2d& v, float t) {
  return Vector2d(v.x*t, v.y*t);
}

inline Vector2d operator * (float t, const Vector2d& v) {
  return Vector2d(v.x*t, v.y*t);
}

inline Vector2d operator + (const Vector2d& v, const Vector2d& w) {
  return Vector2d(v.x+w.x, v.y+w.y);
}

inline Vector2d operator - (const Vector2d& v, const Vector2d& w) {
  return Vector2d(v.x-w.x, v.y-w.y);
}

inline Point2d operator + (const Vector2d& v, const Point2d& p) {
  return Point2d(v.x+p.x, v.y+p.y);
}

inline Point2d operator + (const Point2d& p, const Vector2d& v) {
  return Point2d(p.x+v.x, p.y+v.y);
}

inline Point2d operator - (const Point2d& p, const Vector2d& v) {
  return Point2d(p.x-v.x, p.y-v.y);
}

inline Vector2d operator - (const Point2d& p, const Point2d& q) {
  return Vector2d(p.x-q.x, p.y-q.y);
}

Vector2d normalize(const Vector2d& v) {
  float d = 1.0/sqrt(v.x*v.x+v.y*v.y);
  return Vector2d(v.x*d, v.y*d);
}

inline float dot(const Vector2d& v, const Vector2d& w) {
  return v.x*w.x + v.y*w.y;
}

inline float dist(const Point2d& p, const Point2d& q) {
  return (p-q).length();
}

